unit UFormCPU;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls;

type

  { TFormCPU }

  TFormCPU = class(TForm)
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label7: TLabel;
    LabelMemoryPointer: TLabel;
    LabelProgramPointer: TLabel;
    LabelStepCounter: TLabel;
    LabelStepSpeed: TLabel;
  private
  public
    LastStepCounter: Integer;
    procedure Reload;
  end;

var
  FormCPU: TFormCPU;

implementation

uses
  UCore, UTargetInterpretter;

{$R *.lfm}

resourcestring
  SStepsPerSecond = ' steps/s';

{ TFormCPU }

procedure TFormCPU.Reload;
begin
  if Core.CurrentTarget is TTargetInterpretter then
  with TTargetInterpretter(Core.CurrentTarget) do begin
    LabelProgramPointer.Caption := IntToStr(ProgramIndex);
    LabelMemoryPointer.Caption := IntToStr(MemoryPosition);
    LabelStepCounter.Caption := IntToStr(StepCount);
    LabelStepSpeed.Caption := IntToStr(StepCount - LastStepCounter) + SStepsPerSecond;
    LastStepCounter := StepCount;
  end;
end;

end.

