unit UFormTargets;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ComCtrls;

type

  { TFormCompilers }

  TFormCompilers = class(TForm)
    ListView1: TListView;
    procedure FormShow(Sender: TObject);
    procedure ListView1Data(Sender: TObject; Item: TListItem);
    procedure ListView1DblClick(Sender: TObject);
  private
    { private declarations }
  public
    procedure ReloadList;
  end; 

var
  FormCompilers: TFormCompilers;

implementation

{$R *.lfm}

uses
  UCore, UTarget, UFormTargetOptions;

{ TFormCompilers }

procedure TFormCompilers.FormShow(Sender: TObject);
begin
  ReloadList;
end;

procedure TFormCompilers.ListView1Data(Sender: TObject; Item: TListItem);
begin
  if (Item.Index >= 0) and (Item.Index < Core.Targets.Count) then
  with TTarget(Core.Targets[Item.Index]) do begin
    Item.Caption := Name;
    Item.Data := Core.Targets[Item.Index];
    Item.SubItems.Add(ExecutorPath);
    Item.SubItems.Add(CompilerPath);
  end;
end;

procedure TFormCompilers.ListView1DblClick(Sender: TObject);
begin
  FormTargetOptions.LoadControls(TTarget(ListView1.Selected.Data));
  if FormTargetOptions.ShowModal = mrOk then begin
    FormTargetOptions.SaveControls(TTarget(ListView1.Selected.Data));
    ReloadList;
  end;
end;

procedure TFormCompilers.ReloadList;
begin
  ListView1.Items.Count := Core.Targets.Count;
  ListView1.Refresh;
end;

end.

