unit UTargetPHP;

{$mode Delphi}{$H+}

interface

uses
  Classes, SysUtils, UTarget, UBFTarget;

type

  { TTargetPHP }

  TTargetPHP = class(TBFTarget)
  private
  public
    constructor Create; override;
    procedure Compile; override;
    procedure Run; override;
  end;


implementation

{ TTargetPHP }

constructor TTargetPHP.Create;
begin
  inherited Create;
  Name := 'PHP';
  SourceExtension := '.php';
  RunExtension := '.php';
  CompiledExtension := '.php';
  ImageIndex := 21;
  Capabilities := [tcCompile, tcRun];
  {$IFDEF Windows}
  CompilerPath := '';
  ExecutorPath := 'c:\Program Files\PHP\php.exe';
  {$ENDIF}
  {$IFDEF Linux}
  CompilerPath := '';
  ExecutorPath := '/usr/bin/php';
  {$ENDIF}
end;

procedure TTargetPHP.Compile;
begin
  inherited;
  Indent := 0;
  FTargetCode := '';

  AddLine('<?php // ' + ProgramName);
  AddLine('');
  AddLine('$Memory = str_repeat("\0", 30000);');
  AddLine('$Position = 0;');
  FProgramIndex := 0;
  while (FProgramIndex < Length(FProgram)) do begin
    case FProgram[FProgramIndex].Command of
      cmPointerInc: AddLine('$Position = $Position + ' + IntToStr(FProgram[FProgramIndex].Parameter) + ';');
      cmPointerDec: AddLine('$Position = $Position - ' + IntToStr(FProgram[FProgramIndex].Parameter) + ';');
      cmInc: AddLine('$Memory[$Position] = chr(ord($Memory[$Position]) + ' + IntToStr(FProgram[FProgramIndex].Parameter) + ');');
      cmDec: AddLine('$Memory[$Position] = chr(ord($Memory[$Position]) - ' + IntToStr(FProgram[FProgramIndex].Parameter) + ');');
      cmOutput: AddLine('echo($Memory[$Position]);');
      cmInput: AddLine('$Memory[$Position] = fgetc(STDIN);');
      cmSet: AddLine('$Memory[$Position] = chr(' + IntToStr(FProgram[FProgramIndex].Parameter) + ');');
      cmLoopStart: begin
        AddLine('while($Memory[$Position] != "\0") {');
        Inc(Indent);
      end;
      cmLoopEnd: begin
        Dec(Indent);
        AddLine('}');
      end;
    end;
    Inc(FProgramIndex);
  end;

  CompileToFile;
end;

procedure TTargetPHP.Run;
begin
  inherited Run;
  RunFromFile;
end;

end.

